// TUNING PARAMETERS:
// Here comes the parameters, which need fine tuning.
//NYESI

// TODO: ===============================================================================================


// DECLARATIONS: =======================================================================================


//**Ez itt a kis korbeszaladgalos, lehasalos gyakorlatozo fickok konvoja
const gConvoyTotal = 1;
new gConvoyArray[gConvoyTotal][4] = {{0,0,0}};
new gConvoyNames[gConvoyTotal][25] = {"edz_"};
new gConvoyWPNames[gConvoyTotal][25] = {"wpg"};
new gConvoyCount[gConvoyTotal] = {4};
new gConvoyWPCount[gConvoyTotal] = {17};
new Float:gConvoyStartDelays[gConvoyTotal] = {15.0};
//**

#include "script.inc"
#include "visualeffects.inc"
#include "convoycontrol.inc"

//**Amit dumalnak, ahhoz a kiiras itt lakozik ebben a tombben. Az ures sztring mindig valami vezerles (altalaban amikor eppen nincs duma)
new gSpeechID[49][] = {
		{"#iTUT_01#"},	//0
		{"#iTUT_02#"},	//1 
		{"#iTUT_03#"},	//2	
		{""},			//3
		{"#iTUT_04#"},	//4	
		{"#iTUT_05#"},	//5
		{"#iTUT_06#"},	//6
		{"#iTUT_07#"},	//7
//		{"#iTUT_08#"},	//8 Ez nem kell
		{"#iTUT_09#"},	//9
		{"#iTUT_10#"},	//10
		{"#iTUT_11#"},	//11
		{"#iTUT_12#"},	//12
		{"#iTUT_13#"},	//13
		{"#iTUT_14#"},	//14
		{""},												//15
		{"#iTUT_15#"},	//16
		{""},												//17
		{"#iTUT_16#"},	//18
		{"#iTUT_17#"},	//19
		{"#iTUT_18#"},	//20
		{"#iTUT_19#"},	//21
		{""},												//22
		{"#iTUT_20#"},	//23
		{""},												//24		
		{"#iTUT_21#"},	//25
		{"#iTUT_22#"},	//26
		{"#iTUT_23#"},	//27
		{"#iTUT_24#"},	//28
		{"#iTUT_25#"},	//29
		{""},												//30
		{"#iTUT_26#"},	//31
		{""},												//32
		{"#iTUT_27#"},	//33
		{"#iTUT_28#"},	//34
		{"#iTUT_29#"},	//35
		{"#iTUT_30#"},	//36
		{"#iTUT_31#"},	//37
		{"#iTUT_32#"},	//38
		{"#iTUT_33#"},	//39
		{""},												//40
		{"#iTUT_34#"},	//41
		{""},												//42		
		{"#iTUT_35#"},	//43
		{"#iTUT_36#"},	//44
		{"#iTUT_37#"},	//45
		{"#iTUT_38#"},	//46
		{"#iTUT_39#"},	//47
		{""},												//48
		{"#iTUT_40#"}	//49
}


//**Ez itt a sok duma tombje. Ezeken lepeget vegig a ... fuggveny.
new gSoundID[49][] = {
		{"sounds\\game\\speech\\mission\\Tut_0_001.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_0_002.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_0_003.mp3"},
		{""},
		{"sounds\\game\\speech\\mission\\Tut_1_001.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_1_002.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_1_003.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_1_004.mp3"},
//		{"sounds\\game\\speech\\mission\\Tut_1_006.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_1_007.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_1_009.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_1_010.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_1_011.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_1_012.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_1_013.mp3"},
		{""}, 
		{"sounds\\game\\speech\\mission\\Tut_1_015.mp3"},
		{""},
		{"sounds\\game\\speech\\mission\\Tut_1_016.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_1_017.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_1_018.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_1_019.mp3"},
		{""},
		{"sounds\\game\\speech\\mission\\Tut_2_001.mp3"},
		{""},
		{"sounds\\game\\speech\\mission\\Tut_2_003.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_2_004.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_2_005.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_2_006.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_2_008.mp3"},
		{""},
		{"sounds\\game\\speech\\mission\\Tut_3_001.mp3"},
		{""},
		{"sounds\\game\\speech\\mission\\Tut_3_002.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_3_003.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_3_004.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_3_005.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_3_006.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_3_007.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_3_008.mp3"},
		{""},
		{"sounds\\game\\speech\\mission\\Tut_4_001.mp3"},
		{""},
		{"sounds\\game\\speech\\mission\\Tut_4_002.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_4_003.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_4_004.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_4_005.mp3"},
		{"sounds\\game\\speech\\mission\\Tut_4_006.mp3"},
		{""},
		{"sounds\\game\\speech\\mission\\Tut_5_001.mp3"}
}
new gSpeechCounter = 0; //Ez szamolja, hogy hanyadik dumanal tartunk
//new bool:gFriendly = false; //Friendly fire vizsgaloka
new	gHero[]= "mokus"; //Az officer eppen melyik entitasban van (mokus=onmaga)
new DrID:Comp=DrID:0;		
//new bool:grepcsere=false; //A repzaj amin bejovunk modelljet lecsereljuk nem forgo propellerre
new bool:gindulonemvolt=true; //

//**Ezek a nevezetes pontok, ahanyas szamu lepesnel tortenik valami (objective valtas, valami)
const s1 = 3;
const s2 = 14;
const s3 = 16;
const s4 = 21;
const s5 = 23;
const s6 = 29;
const s7 = 31;
const s8 = 39;
const s9 = 41;
const s10 = 47;
const s11 = 49;
//


//======================================================================================================
public main() // A palya belepesi pontja, helyette a PostGameStart fuggvenyt hasznald
	CommonAKMain();



//======================================================================================================
public PostGameStart()
{
	CommonAKInit();

	AddAKEntityEvent( "TovabbDuma", ANY_ENTITY, MESSAGE_END );
//	AddAKEntityEvent( "invasionintro", ANY_ENTITY, TEST_EVENT );
	AddAKEntityEvent( "AreaEntered", ANY_ENTITY, UNIT_AREA_ENTER );
	AddAKEntityEvent( "AreaExit", ANY_ENTITY, UNIT_AREA_EXIT );	
	AddAKEntityEvent( "SomeoneMounted", ANY_ENTITY, UNIT_MOUNTED );
	AddAKEntityEvent( "SomeoneUnMounted", ANY_ENTITY, UNIT_UNMOUNTED );
	AddAKEntityEvent( "DelayDelay", ANY_ENTITY, UNIT_COMMAND_QUEUE_EMPTY);
	AddAKEntityEvent( "TeamChanged", GetEntity("bazis"), HQ_TAKEOVER );
	AddAKEntityEvent( "Intro3", GetEntity("havi2"), UNIT_STOPPED );	
	AddAKEntityEvent( "GroupD", ANY_ENTITY, GROUPDIED );
	AddAKEntityEvent( "FriendlyFire", ANY_ENTITY, WEAPON_SHOT_AT );
	AddAKEntityEvent( "HeroDied", GetEntity("mokus"), UNIT_DIED );
	AddAKEntityEvent( "FriendlyFire2", ANY_ENTITY, UNIT_DIED );

	
	AddObjective("P1_Tutorial", OT_PRIMARY, "#iO_TUT_PS01#", "#iO_TUT_PL01#", OS_SLEEPING);	
	AddObjective("P2_Flag", OT_PRIMARY, "#iO_TUT_PS02#", "#iO_TUT_PL02#", OS_SLEEPING);	
	AddObjective("S1", OT_SECONDARY, "#iO_TUT_SS01#", "#iO_TUT_SL01#", OS_SLEEPING);	
	AddObjective("S2", OT_SECONDARY, "#iO_TUT_SS02#", "#iO_TUT_SL02#", OS_SLEEPING);
	AddObjective("S3", OT_SECONDARY, "#iO_TUT_SS03#", "#iO_TUT_SL03#", OS_SLEEPING);
	AddObjective("S4", OT_SECONDARY, "#iO_TUT_SS04#", "#iO_TUT_SL04#", OS_SLEEPING);
	AddObjective("S5", OT_SECONDARY, "#iO_TUT_SS05#", "#iO_TUT_SL05#", OS_SLEEPING);
	AddObjective("Hidden", OT_HIDDEN, "#iO_TUT_HS01#", "#iO_TUT_HL01#", OS_SLEEPING);

	Intro();			
/*	ShowTheStats();
	AddAKEntityEvent( "kamera", ANY_ENTITY, TEST_EVENT );*/
}



//======================================================================================================

/*public kamera()
{
	ShowTheStats();
}*/



/*public RepCsere(DrID:Area) //Ha a kamera nem mutatja a repulonket, akkor kicsereljuk allo propellerure
{
	new Float:lOjjectPos[vec3];
	GetPropertyVec3( GetEntity("havi3"), "Pos", lOjjectPos );
	if ((!grepcsere)&&(!IsCameraAt( lOjjectPos, 45)))
	{
		CmdMoveToEntity( GetEntity("havi2"), Q_OVERRIDE, GetEntity("al_reconentry1"), MF_TELEPORT );
		ActivateEntity( GetEntity("havi3") );
		SetPropertyBool( GetEntity("havi3"), "HideModel", false );
		SetPropertyBool( GetEntity("havi3"), "Visible", true );
		SetPropertyBool( GetEntity("havi3"), "Invisible", false );
		RefreshFOW();
		grepcsere=true;
		RemoveEvent( "Repcsere" );
	}
}*/

public HeroDied() //Ha megpusztult volna a hosunk
{
	BulletTime( GetEntity("mokus"));
	ShowShortMessage( "#iTUT_MSG002#" );
	AddTimerEvent( "GameOver", 2.0, "GameLogic", true);
}

public FriendlyFire(DrID:UnitHit, DrID:WhoHit) //Frendlifajor ellenorzo
{
	new team=GetPropertyInt( UnitHit, "Team" )
	new lastteam=GetPropertyInt( UnitHit, "LastTeam" )
	if (((lastteam!=1)&&(IsInSelector( UnitHit, "SelectorTeam2" )||(team==0 )))&& IsInSelector(WhoHit, "SelectorTeam2")&&/*(gFriendly==false)&&*/(WhoHit!=UnitHit))
	{
//	gFriendly=true;
	ShowShortMessage( "#iTUT_MSG001#" );
	BulletTime(UnitHit,false,false,false,10.0,15.0);
	AddTimerEvent( "GameOver", 5.0, "GameLogic", true);
	RemoveEvent( "FriendlyFire" );
	}
}

public FriendlyFire2(DrID:WhoDied) //Ha epuletet detonalok akkor is szamitson friendly fire-nek, kiveve a celpont epuleteket
{
	if(IsInstanceOf( WhoDied, GetClassID( "cBuilding" )))
	{
//	if ((WhoDied==("03_bunker1"))||((WhoDied==GetEntity("04_bunker1")))||(WhoDied==GetEntity("misc_build_tent_013"))||(WhoDied==GetEntity("misc_build_tent_012")))
		if ((GetPropertyInt( WhoDied, "Team" ) !=1 )&&(GetPropertyInt( WhoDied, "LastTeam" ) !=1 ))
		{
	//		gFriendly=true;
			BulletTime(WhoDied,false,false,false,10.0,15.0);
			ShowShortMessage( "#iTUT_MSG001#" );
			AddTimerEvent( "GameOver", 5.0, "GameLogic", true);
		}
	}
}

//V Az intro es folyomanyai

public Intro()
{
	SetCutScene(true,false,true);
	LcvpAnimStop( GetEntity( "us_lcvp1") );
	LcvpAnimStop( GetEntity( "us_lcvp3") );
	LcvpAnimStop( GetEntity( "us_lcvp4") );
	FadeIn(4.0);
	MakeVulnerable(GetEntity("mokus"));
	SetPropertyBool( GetEntity("havi3"), "Visible", false );
	CmdMoveToEntity( GetEntity("havi1"), Q_OVERRIDE, GetEntity("al_support_artillery1"), MF_DIRECT );
	CameraSet(0.0, 56.0, 28.0);
	CameraFollow( GetEntity("havi1") );
	SetPropertyBool( GetEntity("havi2"), "GadgetsVisible", false );
	SetPropertyBool( GetEntity("havi3"), "GadgetsVisible", false );
	ConvoyGo(0,Q_CYCLE,MF_OVERRUN);
	AddTimerEvent( "Intro2", 9.0, "GameLogic", true);
	RemoveEvent( "Intro" );
}

public Intro2()
{
	CameraFollow( GetEntity("maszkal1") );
	CmdUnmount( GetEntity("maszkal1"), Q_OVERRIDE );
	CmdMount( GetEntity("maszkal1"),  Q_ENQUEUE, GetEntity("kocsi") );
	PlayAnim(GetEntity("havi2"), "ROTATE", 3.0, PM_LOOP);
 	CmdMoveToEntity( GetEntity("havi2"), Q_OVERRIDE, GetEntity("havi_cel"), MF_DIRECT );
	AddTimerEvent( "Intro2esfel", 4.0, "GameLogic", true);
	RemoveEvent( "Intro2" );
}

public Intro2esfel()
{
	CameraFollow( GetEntity("kocsi") );
	CmdMoveToEntity( GetEntity("kocsi"), Q_OVERRIDE, GetEntity("kanyar"), MF_OVERRUN );
	CmdMoveToEntity( GetEntity("kocsi"), Q_ENQUEUE, GetEntity("feketeide"), MF_OVERRUN );	
	CmdUnmount( GetEntity("kocsi"), Q_ENQUEUE );
	RemoveEvent( "Intro2esfel" );
}

public Intro3()
{
	StopAnim(GetEntity("havi2"), "ROTATE");
	PlayAnim(GetEntity("havi2"), "END ROTATE");
	CmdMoveToEntity( GetEntity("mokus"), Q_OVERRIDE, GetEntity("mokus_cel"), MF_TELEPORT );	
	CmdWait( GetEntity("mokus"), Q_ENQUEUE, 1.0 );
	CmdMoveToEntity( GetEntity("mokus"), Q_ENQUEUE, GetEntity("indulo"), MF_DIRECT );
	AddTimerEvent( "Intro4", 1.0, "GameLogic", true);
	RemoveEvent( "Intro3" );
}

public Intro4()
{
	CameraFollow( GetEntity("mokus") );	
//	AddAKEntityEvent( "RepCsere", ANY_ENTITY, AREA_CAMERA_EXITED );
	RemoveEvent( "Intro4" );
}

//Intros resz vege.

//Ha meghalt a partraszallok groupja, mission failed.
public GroupD()
{
	new GroupName[20];
	GetMsgParamString( GroupName,20 );
	if (!CompareString( GroupName, "land"))
	{
	 	SetObjectiveState( "P2_Flag", OS_FAILED );
		new DrID:WhoDied = GetLastKilledEntity();
		BulletTime(WhoDied,false,false,false,10.0,15.0);	
//		SetCutScene(true,false,false);
		AddTimerEvent( "GameOver", 1.0, "GameLogic", true);
	}
}

//Elfoglaltuk a bazist, mission success
public TeamChanged()
{
	if (IsPlayer( GetEntity("bazis") ))
	{
	SetObjectiveState( "P2_Flag", OS_COMPLETED );
	SetPropertyFloat( GetEntity("bazis"), "Radius", 0.0 );
	AddTimerEvent( "End", 3.0, "GameLogic", true);
	}
}

//End sequence, gameoverre ugrik
public End()
{
	SetCutScene(true,true,false);
	BulletTime(GetEntity("bazis"),false,false,false,10.0,15.0);
	AddTimerEvent( "GameOver", 1.0, "GameLogic", true);
	RemoveEvent("End");
}

//Legeslegvege
public GameOver()
{	
	if	((GetObjectiveState( "Hidden" )==OS_SLEEPING)||(GetObjectiveState( "Hidden" )==OS_IN_PROGRESS))
	{
	SetObjectiveState( "Hidden", OS_FAILED );
	}
	
	if (GetObjectiveState( "P2_Flag" )==OS_COMPLETED)
	{
		SetCutScene(true,true,false);
		EndMission( MS_ACCOMPLISHED );
	}
	else
	{
		if (GetObjectiveState( "P2_Flag" )==OS_IN_PROGRESS)
		{
		SetObjectiveState( "P2_Flag", OS_FAILED );
		}
		if (GetObjectiveState( "P1_Tutorial" )==OS_IN_PROGRESS)
		{
		SetObjectiveState( "P1_Tutorial", OS_FAILED );
		}
		SetCutScene(true,true,false);
		EndMission( MS_FAILED );
	}
	RemoveEvent( "GameOver" );
}

public TovabbDuma() //Ez az a rettenetes eljaras ami tovabb lepteti a tomboket, es elhallgattatja az eddig szolo dumat
{
	ClearSoundMessages();
	gSpeechCounter++;
	KameraMozgatas(gSpeechCounter);
	NextMsg();
}

public KameraMozgatas(speech)
{ 
	switch(speech)
	{
	case 42:
		{	
			CamPosStore();
			SetCameraRotSpeed(7.0);
			SetCameraSpeed(12.0);
			CameraSet(-35.0, 59.0, 17.0, false);
			MoveCameraToEnt(GetEntity("al_engineer5") );
		}
	case 43:
		{
			SetCameraTargetPos(Float:{222.0,100.0,1.0} );
			CameraSet(90.0, 58.0, 15.0, false);
		}
	case 44:
		{
			SetCameraTargetPos(Float:{242.0,94.0,1.0} );
			CameraSet(-60.0, 58.0, 15.0, false);
		}
	case 45:
		{
			SetCameraTargetPos(Float:{224.0,88.0,1.0});
			CameraSet(177.0, 58.0, 20.0, false);
		}
		
	case 46:
	{
		CamPosRestore();
		CameraSpeed(-1.0,-1.0,-1.0,-1.0);
	}	
	}
}

stock bool:HeroIdle() //Nem mozog-e eppen a hos fuggveny
{
	if (IsMounted( GetEntity("mokus") ))
	{
	Comp=(GetComponent( GetEntity(gHero), "cUnitCommandExecutor"));	
	}
	else
	{
	Comp=(GetComponent( GetEntity("mokus"), "cUnitCommandExecutor"));
	}
	if (GetPropArrayLength( Comp, "Queue")==0)
	{
		return true;
	}
	return false;
}

public NextMsg() //Ez a fergeteges resz mondatja ki a kovetkezo dumat 
{
	ObjectiveWatch()
	if (strlen(gSoundID[gSpeechCounter])==0)
		{
		Control();
		}
	if (((gSpeechCounter<=52) && (strlen(gSoundID[gSpeechCounter])!=0)) )
	{

		AddSoundMessage(gSpeechID[gSpeechCounter], gSoundID[gSpeechCounter], true);
	}
}

public MakeMountIn() //Hogyha az elejen a juzer nem csinal semmit, akkor ez szallitja be a kocsiba es viszi a hazba
{
	if ((IsInSelector( GetEntity("mokus"), "Indulo" ))&&(HeroIdle()) )
	{
	RemoveFromGroup( "Indulo", GetEntity("mokus"));
	SetCutScene(true,false,false); 
	CmdMount( GetEntity("mokus"), Q_URGENT, GetEntity("taliga") );
	CmdMount( GetEntity("mokus"), Q_CYCLE, GetEntity("hq") );
	CmdMoveToEntity ( GetEntity("taliga"), Q_CYCLE, GetEntity("hq_wp"), _ );
	CameraFollow( GetEntity("taliga") );
	CmdStop( GetEntity("taliga"), Q_ENQUEUE );
	CmdUnmount( GetEntity("taliga"), Q_ENQUEUE );	
	AddTimerEvent( "GoIn", 1.0, "GameLogic", true);
	RemoveEvent( "MakeMountIn" );
	}
}

public GoIn() //Valojaban ez viszi be a hazba a ksifickot, ha kimountolt a kocsibol vagy mi...
{
	CmdMount( GetEntity("mokus"), Q_ENQUEUE, GetEntity("hq") );
}

public DelayDelay(DrID:Who) //Ez valami keslelteto
{

	if (Who==GetEntity(gHero))
	{
	AddTimerEvent( "Delay", 5.0, "GameLogic", true);
	}
}

public Delay() //Ezek azt hiszem amikor szunet kell a dumaba
{
	if ((gSpeechCounter==s3) && (HeroIdle()))
	{
	TovabbDuma();
	}
	if ((gSpeechCounter==s5) && (HeroIdle()))
	{
	TovabbDuma();
	}
	if ((gSpeechCounter==s7) && (HeroIdle()))
	{
	TovabbDuma();
	}
	if ((gSpeechCounter==s9) && (HeroIdle()))
	{
	TovabbDuma();
	}
	RemoveEvent( "Delay" );
}

public Control()
{
	if (gSpeechCounter==s1)
	{
		AddTimerEvent( "MakeMountIn", 5.0, "GameLogic", true);
	}
	if (gSpeechCounter==s2)
	{
		CmdUnmount( GetEntity("mokus"), Q_URGENT );

	}
	if (gSpeechCounter==s3)
	{
		AddTimerEvent( "Delay", 5.0, "GameLogic", true);
//d		ShowShortMessage( "Var, hogy elmegyek-e piroshoz" );
	}
	if (gSpeechCounter==s4)
	{
//d		ShowShortMessage( "piros areaba lepesre var" );
	}
	if (gSpeechCounter==s5)
	{
		AddTimerEvent( "Delay", 5.0, "GameLogic", true);
//d		ShowShortMessage( "Var, hogy elmegyek-e zoldhoz" );
	}
	if (gSpeechCounter==s6)
	{
//d		ShowShortMessage( "zold areaba lepesre var" );
	}
	if (gSpeechCounter==s7)
	{
		AddTimerEvent( "Delay", 5.0, "GameLogic", true);
//d		ShowShortMessage( "var, hogy elmegyek-e kekhez" );
	}
	if (gSpeechCounter==s8)
	{
//d		ShowShortMessage( "kek areaba lepesre var" );
	}
	if (gSpeechCounter==s9)
	{
		AddTimerEvent( "Delay", 5.0, "GameLogic", true);
//d		ShowShortMessage( "var, hogy elmegyek-e sargahoz" );
	}
	if (gSpeechCounter==s10)
	{
//d		ShowShortMessage( "sarga areaba lepesre var" );
	}
}

public SomeoneMounted( DrID:UndWho, DrID:UndWhere )
{
	new DrID:HeroBacsi = GetEntity( gHero );
	new DrID:House = GetEntity( "hq" );

	//Ha az officer bemountol valahova, leszedi a szelekciot rola. Volt egy bug, hogy minden areaba lepeskor valamiert megint kiszelektalodott a jarmu belsejeben
	if 	((UndWho == HeroBacsi)) 
	{
	RemoveFromGroup( "Selection", HeroBacsi );
	}
	//Hidden teljesitese, ha a radio towerbe mountolunk	
	if 	((UndWho == HeroBacsi) && (UndWhere==GetEntity("tut_radiotower1"))&&(GetObjectiveState( "Hidden" )==OS_SLEEPING) )
	{
	SetObjectiveState( "Hidden", OS_COMPLETED );
	}
	//Ha bemountolunk valahova, a gHero a jarmu StringID-jat kapja
	if 	((UndWho == HeroBacsi) && (IsInstanceOf( UndWhere, GetClassID("cVehicle"))))
	{
		GetPropertyString( UndWhere, "StringID", 40, gHero );
	}
	//Ha a HQ-ba mountolunk, akkor elkezd dumalni, plusz mikor automatikusan montolunk bele, bevegzi a cutscenet
	if  ((UndWhere == House) && (UndWho == HeroBacsi))
	{
		RemoveEvent( "GoIn" );
		CameraFollow( DrID:0 );
		SetCutScene(false,false,false);
		gSpeechCounter=s1;
		TovabbDuma();
	}
}

public SomeoneUnMounted( DrID:UndWho, DrID:UndFromWhere )
{
	new DrID:KocsiBacsi = GetEntity( "maszkal1" );
	new DrID:HeroBacsi = GetEntity( "mokus" );
	new DrID:House = GetEntity( "hq" );
	
	//Ez eltunteti a kiscsakot aki az introban vezeti a fekete autot
	if 	((UndWho == KocsiBacsi)&&(UndFromWhere==GetEntity("kocsi")))
	{
		CmdMoveToEntity( (KocsiBacsi), Q_OVERRIDE, GetEntity("al_airstrikeentry1"), MF_TELEPORT );
	}
	//Ha kimountolunk, a gHero megint mokus lesz.
	if 	(UndWho == HeroBacsi)
	{
		gHero="mokus";
	}
	//A HQ-bol kimountolva jon a kovetkezo resz
	if  ((UndFromWhere == House) && (UndWho == HeroBacsi))
	{
		gSpeechCounter=s2;
		TovabbDuma();		
	}
	//Az LCI-bol kimountolnak a partraszallo kiscsakok, es a waypointokhoz robognak
	if  (IsInSelector( UndFromWhere, "LCI" ))
	{
		if (UndFromWhere==GetEntity("us_lcvp1"))
		{
			CmdMoveToEntity( UndWho, Q_ENQUEUE, GetEntity("wpb1"), MF_DIRECT );
		}
/*		if (UndFromWhere==GetEntity("us_lcvp2"))
		{
			CmdMoveToEntity( UndWho, Q_ENQUEUE, GetEntity("wpb2"), MF_DIRECT );
		}
*/		
		if (UndFromWhere==GetEntity("us_lcvp3"))
		{
			CmdMoveToEntity( UndWho, Q_ENQUEUE, GetEntity("wpb3"), MF_DIRECT );
		}
		if (UndFromWhere==GetEntity("us_lcvp4"))
		{
			CmdMoveToEntity( UndWho, Q_ENQUEUE, GetEntity("wpb4"), MF_DIRECT );
		}		
	}
}

public AreaEntered(DrID:WhoEntered, DrID:AreaID)
{

	if ((AreaID==GetEntity("part_main"))&&(IsInSelector( WhoEntered, "Ssima" )))//A DDSHERMAN vizi uzemmodba valt
	{
		PlayAnim(WhoEntered, "CANVAS_UP");
		ShipMode(WhoEntered, true);
	}
	if ((AreaID==GetEntity("part_sziget"))&&(IsInSelector( WhoEntered, "Ssima" )))//A DDSHERMAN szarazfoldi uzemmodba valt
	{
		PlayAnim(WhoEntered, "CANVAS_DOWN");
		ShipMode(WhoEntered, false);		
	}
	if ((AreaID==GetEntity("kussz"))&&(IsInSelector( WhoEntered, "trening" )))//kuszas
	{
		CmdSetMS( WhoEntered, Q_URGENT, MS_CRAWL );
	}
	if ((WhoEntered==GetEntity("havi2")) && (AreaID==GetEntity("havibe") )) //intro3
	{
		CameraFollow( GetEntity("havi2"));
		CameraSet(-20.0, 56.0, 28.0);
	}

	if ((WhoEntered==GetEntity("havi2")) && (AreaID==GetEntity("havi_effekt1") )) //intro3
	{
		StopAnim(GetEntity("havi2"), "ROTATE");
		PlayAnim(GetEntity("havi2"), "ROTATE", 2.4, PM_LOOP);
	}

	if ((WhoEntered==GetEntity("havi2")) && (AreaID==GetEntity("havi_effekt2") )) //intro3
	{
		StopAnim(GetEntity("havi2"), "ROTATE");
		PlayAnim(GetEntity("havi2"), "ROTATE", 1.7, PM_LOOP);
	}

	if ((WhoEntered==GetEntity("havi2")) && (AreaID==GetEntity("havi_effekt3") )) //intro3
	{
		StopAnim(GetEntity("havi2"), "ROTATE");
		PlayAnim(GetEntity("havi2"), "ROTATE", 1.0, PM_LOOP);
	}

	if ((WhoEntered==GetEntity("kocsi")) && (AreaID==GetEntity("sys_rectarea1") )) //intro3
		{
		ShowShortMessage( "#b##b##d##c255,200,0##ac#You find a paper with an old writing:");
		ShowShortMessage( "#d##c235,0,0##ac#IT's under the church in St. Mere!");
		}


	if ((WhoEntered==GetEntity("mokus")) && (AreaID==GetEntity("indulo") )) //intro4
		{
		if (gindulonemvolt)
		{
			CameraFollow( DrID:0 );
			MoveCameraToEnt( GetEntity("indulo") );
			SetCutScene(false,false,false);
			AddToGroup( "Selection", GetEntity("mokus"));
			AddToGroup( "Indulo", GetEntity("mokus"));
			NextMsg();
			gindulonemvolt=false;
		}
		}
	//belelep areaba, akkor az odavago duma kezdodik
	if ((WhoEntered==GetEntity("mokus")) && (!IsInSelector( GetEntity("mokus"), "Garea_red" ))&&(!IsInSelector( GetEntity("mokus"), "Garea_green" ))&&(!IsInSelector( GetEntity("mokus"), "Garea_blue" ))&&(!IsInSelector( GetEntity("mokus"), "Garea_yellow" )))
	{
		if (AreaID==GetEntity("area_red"))
		{
//d		ShowShortMessage( "piros" );
		AddToGroup( "Garea_red", GetEntity("mokus") );
		gSpeechCounter=s4;
		TovabbDuma();
		}
		if (AreaID==GetEntity("area_green"))
		{
		AddToGroup( "Garea_green", GetEntity("mokus") );
//d		ShowShortMessage( "zold" );
		gSpeechCounter=s6;
		TovabbDuma();
		}
		if (AreaID==GetEntity("area_blue"))
		{
		AddToGroup( "Garea_blue", GetEntity("mokus") );
//d		ShowShortMessage( "kek" );
		gSpeechCounter=s8;
		TovabbDuma();
		}
		if (AreaID==GetEntity("area_yellow"))
		{
		AddToGroup( "Garea_yellow", GetEntity("mokus") );
//d		ShowShortMessage( "sarga" );
		gSpeechCounter=s10;
		TovabbDuma();
		}
	}
	//megerkeznek a partraszallo hajok, leallnak, es kinyilik az ajto.

	if ((IsInSelector(  WhoEntered, "LCI" ))&& (AreaID==GetEntity("part_sziget")))
	{
		CmdStop( WhoEntered, Q_URGENT );
		CmdWait( WhoEntered, Q_ENQUEUE, 0.4);
		PlayAnim((WhoEntered), "OPEN");
		CmdUnmount( WhoEntered, Q_ENQUEUE, UMTF_UNMOUNT_ALL );
		MakeNOTMountable(WhoEntered);
	}

	if ((IsInSelector( WhoEntered, "LCI" ))&& (AreaID==GetEntity("effektki")))
	{
		LcvpAnimStop( WhoEntered );
	}

	//Ez itt a partraszallo anim vegenek vezerlese
	if (WhoEntered==GetEntity("al_engineer10")&& (AreaID==GetEntity("part_sziget") ))
	{
 		MakeVulnerable(GetEntity("al_engineer10"));
 		SetCutScene(false,false,false);
		CameraFollow( DrID:0 );
		MakeVulnerable(GetEntity("mokus"));
	}

	if (IsInSelector( WhoEntered, "Ssima" )&& (AreaID==GetEntity("part_sziget") ))
	{
		MakeSelectable(GetEntity("al_m4 sherman_dd2"));
 		MakeSelectable(GetEntity("al_m4 sherman_dd1"));
 		MakeSelectable(GetEntity("al_m4 sherman_dd3"));
	}

	if ((IsInSelector( WhoEntered, "LCI" ))&& (AreaID==GetEntity("effektbe")))
	{
		LcvpAnimPlay( WhoEntered );
	}

	if ((IsInSelector( WhoEntered, "egy" ))&& (AreaID==GetEntity("area_egy")))
	{
	CmdGroupMoveToEnt( "egy", GetEntity("hely1"), Q_OVERRIDE, MF_OVERRUN );
	CmdSetMS( WhoEntered, Q_ENQUEUE, MS_CRAWL );
	RemoveFromGroup( "egy", WhoEntered );
	}
	if ((IsInSelector( WhoEntered, "ketto" ))&& (AreaID==GetEntity("area_ketto")))
	{
	CmdGroupMoveToEnt( "ketto", GetEntity("hely2"), Q_OVERRIDE, MF_OVERRUN );
	CmdSetMS( WhoEntered, Q_ENQUEUE, MS_CRAWL );
	RemoveFromGroup( "ketto", WhoEntered );
	}
	if ((IsInSelector( WhoEntered, "harom" ))&& (AreaID==GetEntity("area_harom")))
	{
	CmdGroupMoveToEnt( "harom", GetEntity("hely3"), Q_OVERRIDE, MF_OVERRUN );
	CmdSetMS( WhoEntered, Q_ENQUEUE, MS_CRAWL );
	RemoveFromGroup( "harom", WhoEntered );
	}
	if ((IsInSelector( WhoEntered, "negy" ))&& (AreaID==GetEntity("area_negy")))
	{
	CmdGroupMoveToEnt( "negy", GetEntity("hely4"), Q_OVERRIDE, MF_OVERRUN );
	CmdSetMS( WhoEntered, Q_ENQUEUE, MS_CRAWL );
	RemoveFromGroup( "negy", WhoEntered );
	}
}

public AreaExit(DrID:WhoExited, DrID:AreaID)
{
	if ((AreaID==GetEntity("kussz"))&&(IsInSelector( WhoExited, "trening" )))//kuszasbol felall
	{
		CmdSetMS( WhoExited, Q_URGENT, MS_RUN );
	}
	//Ha kilepkedunk areakbol, akkor mi legyen
	if (WhoExited==GetEntity("mokus"))
	{
		if ((AreaID==GetEntity("area_red"))&&((!IsInSelector( GetEntity("mokus"), "Garea_blue"))&&(!IsInSelector( GetEntity("mokus"), "Garea_green"))&&(!IsInSelector( GetEntity("mokus"), "Garea_yellow"))))
		{
		RemoveFromGroup( "Garea_red", GetEntity("mokus") );
		gSpeechCounter=s6-1;
		TovabbDuma();
		}
		if ((AreaID==GetEntity("area_yellow"))&&((!IsInSelector( GetEntity("mokus"), "Garea_blue"))&&(!IsInSelector( GetEntity("mokus"), "Garea_green"))&&(!IsInSelector( GetEntity("mokus"), "Garea_red"))))
		{
		RemoveFromGroup( "Garea_yellow", GetEntity("mokus") );
		gSpeechCounter=53;
		TovabbDuma();
		}
		if ((AreaID==GetEntity("area_green"))&&((!IsInSelector( GetEntity("mokus"), "Garea_blue"))&&(!IsInSelector( GetEntity("mokus"), "Garea_yellow"))&&(!IsInSelector( GetEntity("mokus"), "Garea_red"))))
		{
		RemoveFromGroup( "Garea_green", GetEntity("mokus") );
		gSpeechCounter=s8-1;
		TovabbDuma();
		}
		if ((AreaID==GetEntity("area_blue"))&&((!IsInSelector( GetEntity("mokus"), "Garea_green"))&&(!IsInSelector( GetEntity("mokus"), "Garea_yellow"))&&(!IsInSelector( GetEntity("mokus"), "Garea_red"))))
		{
		RemoveFromGroup( "Garea_blue", GetEntity("mokus") );
		gSpeechCounter=s10-1;
		TovabbDuma();
		}
		if (IsInSelector( GetEntity("mokus"), "Indulo" ))
		{
		RemoveFromGroup( "Indulo", GetEntity("mokus"));
		}
	}
}

public invasionintro() //Ez itt lenni mindenfele partraszallos cuccos.
{
	CmdStop( GetEntity("mokus"), Q_OVERRIDE );
	RemoveFromGroup( "Selection", GetEntity("mokus"));
	SetPropertyBool( GetEntity("mokus"), "ControlDisabled", true );
	SetCutScene(true,false,false);
	SetCameraTargetDistance( 44.2 );
	SetCameraTargetRotate(25.0);
	SetCameraTargetPitch(60.0);
	CameraFollow( GetEntity("al_engineer10") );
	CmdWait( GetEntity("us_lcvp3"), Q_OVERRIDE, 2.0 );
	CmdWait( GetEntity("us_lcvp4"), Q_OVERRIDE, 3.0 );
	CmdMoveToEntity( GetEntity("us_lcvp1"), Q_OVERRIDE, GetEntity("wpr1"), MF_DIRECT );
	CmdMoveToEntity( GetEntity("us_lcvp3"), Q_ENQUEUE, GetEntity("wpr3"), MF_DIRECT );
	CmdMoveToEntity( GetEntity("us_lcvp4"), Q_ENQUEUE, GetEntity("wpr4"), MF_DIRECT );
	CmdWait( GetEntity("al_m4 sherman_dd2"), Q_OVERRIDE, 0.5 );
	CmdWait( GetEntity("al_m4 sherman_dd1"), Q_OVERRIDE, 10.0 );
	CmdWait( GetEntity("al_m4 sherman_dd3"), Q_OVERRIDE, 7.0 );
	CmdMoveToEntity( GetEntity("al_m4 sherman_dd2"), Q_ENQUEUE, GetEntity("tankoknak1"), MF_DIRECT );
	CmdAttack( GetEntity("al_m4 sherman_dd2"), Q_ENQUEUE, GetEntity("ax_pziiiflame1") );	
	CmdMoveToEntity( GetEntity("al_m4 sherman_dd1"), Q_ENQUEUE, GetEntity("tankoknak2"), MF_DIRECT );
	CmdMoveToEntity( GetEntity("al_m4 sherman_dd3"), Q_ENQUEUE, GetEntity("tankoknak3"), MF_DIRECT );
	SetAirStrike(2,1);
	SetAirRecon(2,1);
	SetArtilleryAttack(2,1);
	SetPropertyBool( GetEntity("bazis"), "VisibleOnMiniMap", true );
//	SetParatroopers(2,1);
	RemoveEvent( "invasionintro" );
}

public LcvpAnimPlay(DrID:Who)
{
	SetPropertyBool( GetComponent( Who , "cEffectController"), "PermanentEffectEnabled", true );
}

public LcvpAnimStop(DrID:Who)
{
	SetPropertyBool( GetComponent( Who , "cEffectController"), "PermanentEffectEnabled", false );
}

public ObjectiveWatch()
{
	switch (gSpeechCounter)
	{
	case 0:
	{
		SetObjectiveState( "P1_Tutorial", OS_IN_PROGRESS );
	}
	case s1:
	{
		if (GetObjectiveState( "S1" )==OS_SLEEPING)
		{
		SetObjectiveState( "S1", OS_IN_PROGRESS );
		}
	}
	case s1+1:
	{
		if (GetObjectiveState( "S1" )==OS_SLEEPING)
		{
		SetObjectiveState( "S1", OS_IN_PROGRESS );
		}
	}
	case s2:
	{
		if (GetObjectiveState( "S1" )==OS_IN_PROGRESS)
		{
			SetObjectiveState( "S1", OS_COMPLETED );
		}
	}
	case s3:
	{
		if (GetObjectiveState( "S2" )==OS_SLEEPING)
		{
		SetObjectiveState( "S2", OS_IN_PROGRESS );
		}
	}
	case s3+1:
	{
		if (GetObjectiveState( "S2" )==OS_SLEEPING)
		{
		SetObjectiveState( "S2", OS_IN_PROGRESS );
		}
	}
	case s4:
	{
		if (GetObjectiveState( "S2" )==OS_IN_PROGRESS)
		{
			SetObjectiveState( "S2", OS_COMPLETED );
		}
	}
	case s5:
	{
		if (GetObjectiveState( "S3" )==OS_IN_PROGRESS)
		{}
		else SetObjectiveState( "S3", OS_IN_PROGRESS );
	}
	case s5+1:
	{
		if (GetObjectiveState( "S3" )==OS_IN_PROGRESS)
		{}
		else SetObjectiveState( "S3", OS_IN_PROGRESS );
	}
	case s6:
	{
		if (GetObjectiveState( "S3" )==OS_IN_PROGRESS)
		{
			SetObjectiveState( "S3", OS_COMPLETED );
		}
	}
	case s7:
	{
		if (GetObjectiveState( "S4" )==OS_IN_PROGRESS)
		{}
		else SetObjectiveState( "S4", OS_IN_PROGRESS );
	}
	case s7+1:
	{
		if (GetObjectiveState( "S4" )==OS_IN_PROGRESS)
		{}
		else SetObjectiveState( "S4", OS_IN_PROGRESS );
	}
	case s8:
	{
		if (GetObjectiveState( "S4" )==OS_IN_PROGRESS)
		{
			SetObjectiveState( "S4", OS_COMPLETED );
		}
	}
	case s9:
	{
		if (GetObjectiveState( "S5" )==OS_IN_PROGRESS)
		{}
		else SetObjectiveState( "S5", OS_IN_PROGRESS );
	}
	case s9+1:
	{
		if (GetObjectiveState( "S5" )==OS_IN_PROGRESS)
		{}
		else SetObjectiveState( "S5", OS_IN_PROGRESS );
	}
	case s10:
	{
		if (GetObjectiveState( "S5" )==OS_IN_PROGRESS)
		{
			SetObjectiveState( "S5", OS_COMPLETED );
		}
	}
	case s11:
	{
		if ((GetObjectiveState( "S1" )==OS_COMPLETED)&&
			(GetObjectiveState( "S2" )==OS_COMPLETED)&&
			(GetObjectiveState( "S3" )==OS_COMPLETED)&&
			(GetObjectiveState( "S4" )==OS_COMPLETED)&&
			(GetObjectiveState( "S5" )==OS_COMPLETED)&&
			(SetObjectiveState( "P1_Tutorial", OS_IN_PROGRESS)))
		{
			SetObjectiveState( "P1_Tutorial", OS_COMPLETED );
		}
		else
		{
			SetObjectiveState( "P1_Tutorial", OS_CANCELLED );		
		}
		AddTimerEvent( "invasionintro", 5.0, "GameLogic", true);
		SetObjectiveState( "P2_Flag", OS_IN_PROGRESS );
	}
	}
}


//======================================================================================================
// Add your functions here:




//======================================================================================================
public ObjectiveChanged()
{
	// Check objectives here
}
